/*
 * Digitale Dörfer Plattform
 * Copyright (C) Fraunhofer IESE 2015 - 2018 Axel Wickenkamp, Balthasar Weitzel
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhg.iese.dd.platform.datamanagement.communication.model;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Convert;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;

import de.fhg.iese.dd.platform.datamanagement.framework.NamingStrategy;
import de.fhg.iese.dd.platform.datamanagement.framework.NamingStrategyName;
import de.fhg.iese.dd.platform.datamanagement.framework.model.BaseEntity;
import de.fhg.iese.dd.platform.datamanagement.participants.person.model.Person;
import de.fhg.iese.dd.platform.datamanagement.shared.encryption.EncryptionConverter;
import de.fhg.iese.dd.platform.datamanagement.shared.files.model.MediaItem;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.experimental.SuperBuilder;

@Entity
@NamingStrategy(strategy = NamingStrategyName.CLASSNAME)
@Getter
@Setter
@SuperBuilder
@NoArgsConstructor
public class ChatMessage extends BaseEntity {

    @ManyToOne
    private Person sender;

    @Column(length = BaseEntity.MAXIMAL_TEXT_LENGTH)
    @Convert( converter = EncryptionConverter.class )
    private String message;

    @OneToOne(cascade = CascadeType.ALL, orphanRemoval = true)
    private MediaItem mediaItem;

    @Column
    private long sentTime;

    @Column
    private boolean autoGenerated;

    @Column
    private String referencedEntityName;

    @Column(length = 36)
    private String referencedEntityId;

    @ManyToOne
    @JoinColumn(name="chat_id")
    private Chat chat;

    public ChatMessage withCreated(long created){
        this.created = created;
        return this;
    }

    @Override
    public String toString() {
        return "ChatMessage [id=" +
                id +
                ", sender=" +
                sender +
                ", sentTime=" +
                sentTime +
                ", createdTime=" +
                created +
                ", autoGenerated=" +
                autoGenerated +
                "]";
    }

}
